// ThreatCon Widget
// main.js
// All code copyright (c) 2006, Martin Koistinen

var lastUpdate = 0;
var	url = new URL();
var alertTimer = false;
var oldThreatLevel = -1;
var oldWindowLevel = null;

function timerAction()
{
	var now = new Date().valueOf();
	if (now - lastUpdate > (1.0 * preferences.frequency.value))
	{
		updateDisplay();
	}
}

function fetchLevel()
{
	response = url.fetch();
	pattern = /threatcon_level(.)\.gif/
	if (pattern.test(response))
	{
		newThreatLevel = pattern.exec(response)[1];
		return newThreatLevel;
	}
	else
	{
		return 0;
	}	
}

function getAttention()
{
	// Simply raise the window-level of the widget to Top Most for 10 Seconds
	if (preferences.alertWindowLevel.value == 1)
	{
		if (!alertTimer)
		{
			// Make a new timer if necessary.
			alertTimer = new Timer();
			alertTimer.ticking = false;
			alertTimer.interval = 10;
			alertTimer.onTimerFired = "mainWindow.level = oldWindowLevel; updateNow(); alertTimer.ticking = false;";
		}
		
		// Let'er rip
		oldWindowLevel = mainWindow.level;
		mainWindow.level = "topMost";
		alertTimer.ticking = true;
	}
	
	if (preferences.alertSound.value == 1)
	{
		play("resources/shake.wav");
	}
	
	if (preferences.alertShake.value == 1)
	{
		tx = mainWindow.hOffset;
		ty = mainWindow.vOffset;

		// Now, shake the window for 0.750 seconds (approximately the same time-length as the shake.wav sound)
		now = new Date();
		later = now.valueOf() + 750;
		updateNow();
		while (now < later)
		{
			x = Math.sin(now/1.8 * (Math.PI/20)) * 3;
			y = Math.cos(now/2.3 * (Math.PI/30)) * 3;
			mainWindow.hOffset = tx + x;
			mainWindow.vOffset = ty + y;
			updateNow();
			now = new Date().valueOf();
		}

		mainWindow.hOffset = tx;
		mainWindow.vOffset = ty;
	}
}

function preferencesChanged()
{
	if (preferences.style.value == "simple")
	{
		base.opacity = 0;
	}
	else
	{
		base.opacity = 255;
	}
	
	if (preferences.testMode.value == 1)
	{
		getAttention();
		showWidgetPreferences();
	}
	
	updateNow();
}

function updateDisplay(forced)
{
	if (forced)
	{
		threatLevel.src="resources/threatcon_level0.png";
		updateNow();
	}
	
	newThreatLevel = fetchLevel();
	
	if (newThreatLevel > 0)
	{
		threatLevel.src="http://www.symantec.com/img/threatcon/threatcon_level" + newThreatLevel + ".gif";
		updateNow();
		lastUpdate = new Date().valueOf();
		
		if ( oldThreatLevel > -1 &&
			(preferences.alertCondition.value == "changes" && newThreatLevel != oldThreatLevel) ||
			(preferences.alertCondition.value == "rises" && newThreatLevel > oldThreatLevel) ||
			(preferences.alertCondition.value == "lowers" && newThreatLevel < oldThreatLevel)
		)
		{
			getAttention();
		}
		oldThreatLevel = newThreatLevel;
	}
	else
	{
		// Hmmm, something was wrong.  Let's try again in 5 minutes
		threatLevel.src="resources/threatcon_level0.png";
		updateNow();
		lastUpdate = new Date().valueOf() + preferences.frequency.value - 300000;
	}
}

url.location = "http://www.symantec.com/index.htm";
preferencesChanged();
updateDisplay();
